(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('diff'), require('diff2html'), require('@angular/platform-browser'), require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('ng-code-diff', ['exports', 'diff', 'diff2html', '@angular/platform-browser', '@angular/core'], factory) :
    (factory((global['ng-code-diff'] = {}),global.diff,global.diff2html,global.ng.platformBrowser,global.ng.core));
}(this, (function (exports,diff,diff2html,platformBrowser,i0) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgCodeDiffService = /** @class */ (function () {
        function NgCodeDiffService() {
        }
        NgCodeDiffService.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        NgCodeDiffService.ctorParameters = function () { return []; };
        /** @nocollapse */ NgCodeDiffService.ngInjectableDef = i0.defineInjectable({ factory: function NgCodeDiffService_Factory() { return new NgCodeDiffService(); }, token: NgCodeDiffService, providedIn: "root" });
        return NgCodeDiffService;
    }());

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgCodeDiffComponent = /** @class */ (function () {
        function NgCodeDiffComponent(sanitizer) {
            this.sanitizer = sanitizer;
        }
        /**
         * @return {?}
         */
        NgCodeDiffComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                this.html = this.sanitizer.bypassSecurityTrustHtml(this.createdHtml(this.oldStr, this.newStr, this.context, this.outputFormat));
            };
        /**
         * @return {?}
         */
        NgCodeDiffComponent.prototype.ngOnChanges = /**
         * @return {?}
         */
            function () {
                this.html = this.sanitizer.bypassSecurityTrustHtml(this.createdHtml(this.oldStr, this.newStr, this.context, this.outputFormat));
            };
        /**
         * @param {?} oldString
         * @param {?} newString
         * @param {?} context
         * @param {?} outputFormat
         * @return {?}
         */
        NgCodeDiffComponent.prototype.createdHtml = /**
         * @param {?} oldString
         * @param {?} newString
         * @param {?} context
         * @param {?} outputFormat
         * @return {?}
         */
            function (oldString, newString, context, outputFormat) {
                /** @type {?} */
                var args = ['', oldString || '', newString || '', '', '', { context: context }];
                /** @type {?} */
                var dd = diff.createPatch.apply(void 0, __spread(args));
                /** @type {?} */
                var outStr = diff2html.Diff2Html.getJsonFromDiff(dd, { inputFormat: 'diff', outputFormat: outputFormat, showFiles: false, matching: 'lines' });
                /** @type {?} */
                var html = diff2html.Diff2Html.getPrettyHtml(outStr, { inputFormat: 'json', outputFormat: outputFormat, showFiles: false, matching: 'lines' });
                return this.hljs(html);
            };
        /**
         * @param {?} html
         * @return {?}
         */
        NgCodeDiffComponent.prototype.hljs = /**
         * @param {?} html
         * @return {?}
         */
            function (html) {
                return html.replace(/<span class="d2h-code-line-ctn">(.+?)<\/span>/g, '<span class="d2h-code-line-ctn"><code>$1</code></span>');
            };
        NgCodeDiffComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'ng-code-diff',
                        template: "\n  <div id=\"code-diff\" [innerHtml]=\"html\"></div>\n  "
                    }] }
        ];
        /** @nocollapse */
        NgCodeDiffComponent.ctorParameters = function () {
            return [
                { type: platformBrowser.DomSanitizer }
            ];
        };
        NgCodeDiffComponent.propDecorators = {
            oldStr: [{ type: i0.Input }],
            newStr: [{ type: i0.Input }],
            context: [{ type: i0.Input }],
            outputFormat: [{ type: i0.Input }]
        };
        return NgCodeDiffComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgCodeDiffModule = /** @class */ (function () {
        function NgCodeDiffModule() {
        }
        NgCodeDiffModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [NgCodeDiffComponent],
                        imports: [],
                        exports: [NgCodeDiffComponent]
                    },] }
        ];
        return NgCodeDiffModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.NgCodeDiffService = NgCodeDiffService;
    exports.NgCodeDiffComponent = NgCodeDiffComponent;
    exports.NgCodeDiffModule = NgCodeDiffModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=ng-code-diff.umd.js.map