import { createPatch } from 'diff';
import { Diff2Html } from 'diff2html';
import { DomSanitizer } from '@angular/platform-browser';
import { Injectable, Component, Input, NgModule, defineInjectable } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgCodeDiffService {
    constructor() { }
}
NgCodeDiffService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
NgCodeDiffService.ctorParameters = () => [];
/** @nocollapse */ NgCodeDiffService.ngInjectableDef = defineInjectable({ factory: function NgCodeDiffService_Factory() { return new NgCodeDiffService(); }, token: NgCodeDiffService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgCodeDiffComponent {
    /**
     * @param {?} sanitizer
     */
    constructor(sanitizer) {
        this.sanitizer = sanitizer;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.html = this.sanitizer.bypassSecurityTrustHtml(this.createdHtml(this.oldStr, this.newStr, this.context, this.outputFormat));
    }
    /**
     * @return {?}
     */
    ngOnChanges() {
        this.html = this.sanitizer.bypassSecurityTrustHtml(this.createdHtml(this.oldStr, this.newStr, this.context, this.outputFormat));
    }
    /**
     * @param {?} oldString
     * @param {?} newString
     * @param {?} context
     * @param {?} outputFormat
     * @return {?}
     */
    createdHtml(oldString, newString, context, outputFormat) {
        /** @type {?} */
        const args = ['', oldString || '', newString || '', '', '', { context: context }];
        /** @type {?} */
        const dd = createPatch(...args);
        /** @type {?} */
        const outStr = Diff2Html.getJsonFromDiff(dd, { inputFormat: 'diff', outputFormat: outputFormat, showFiles: false, matching: 'lines' });
        /** @type {?} */
        const html = Diff2Html.getPrettyHtml(outStr, { inputFormat: 'json', outputFormat: outputFormat, showFiles: false, matching: 'lines' });
        return this.hljs(html);
    }
    /**
     * @param {?} html
     * @return {?}
     */
    hljs(html) {
        return html.replace(/<span class="d2h-code-line-ctn">(.+?)<\/span>/g, '<span class="d2h-code-line-ctn"><code>$1</code></span>');
    }
}
NgCodeDiffComponent.decorators = [
    { type: Component, args: [{
                selector: 'ng-code-diff',
                template: `
  <div id="code-diff" [innerHtml]="html"></div>
  `
            }] }
];
/** @nocollapse */
NgCodeDiffComponent.ctorParameters = () => [
    { type: DomSanitizer }
];
NgCodeDiffComponent.propDecorators = {
    oldStr: [{ type: Input }],
    newStr: [{ type: Input }],
    context: [{ type: Input }],
    outputFormat: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgCodeDiffModule {
}
NgCodeDiffModule.decorators = [
    { type: NgModule, args: [{
                declarations: [NgCodeDiffComponent],
                imports: [],
                exports: [NgCodeDiffComponent]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgCodeDiffService, NgCodeDiffComponent, NgCodeDiffModule };

//# sourceMappingURL=ng-code-diff.js.map