import { __spread } from 'tslib';
import { createPatch } from 'diff';
import { Diff2Html } from 'diff2html';
import { DomSanitizer } from '@angular/platform-browser';
import { Injectable, NgModule, defineInjectable, Component, Input } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgCodeDiffService = /** @class */ (function () {
    function NgCodeDiffService() {
    }
    NgCodeDiffService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    NgCodeDiffService.ctorParameters = function () { return []; };
    /** @nocollapse */ NgCodeDiffService.ngInjectableDef = defineInjectable({ factory: function NgCodeDiffService_Factory() { return new NgCodeDiffService(); }, token: NgCodeDiffService, providedIn: "root" });
    return NgCodeDiffService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgCodeDiffComponent = /** @class */ (function () {
    function NgCodeDiffComponent(sanitizer) {
        this.sanitizer = sanitizer;
    }
    /**
     * @return {?}
     */
    NgCodeDiffComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.html = this.sanitizer.bypassSecurityTrustHtml(this.createdHtml(this.oldStr, this.newStr, this.context, this.outputFormat));
    };
    /**
     * @return {?}
     */
    NgCodeDiffComponent.prototype.ngOnChanges = /**
     * @return {?}
     */
    function () {
        this.html = this.sanitizer.bypassSecurityTrustHtml(this.createdHtml(this.oldStr, this.newStr, this.context, this.outputFormat));
    };
    /**
     * @param {?} oldString
     * @param {?} newString
     * @param {?} context
     * @param {?} outputFormat
     * @return {?}
     */
    NgCodeDiffComponent.prototype.createdHtml = /**
     * @param {?} oldString
     * @param {?} newString
     * @param {?} context
     * @param {?} outputFormat
     * @return {?}
     */
    function (oldString, newString, context, outputFormat) {
        /** @type {?} */
        var args = ['', oldString || '', newString || '', '', '', { context: context }];
        /** @type {?} */
        var dd = createPatch.apply(void 0, __spread(args));
        /** @type {?} */
        var outStr = Diff2Html.getJsonFromDiff(dd, { inputFormat: 'diff', outputFormat: outputFormat, showFiles: false, matching: 'lines' });
        /** @type {?} */
        var html = Diff2Html.getPrettyHtml(outStr, { inputFormat: 'json', outputFormat: outputFormat, showFiles: false, matching: 'lines' });
        return this.hljs(html);
    };
    /**
     * @param {?} html
     * @return {?}
     */
    NgCodeDiffComponent.prototype.hljs = /**
     * @param {?} html
     * @return {?}
     */
    function (html) {
        return html.replace(/<span class="d2h-code-line-ctn">(.+?)<\/span>/g, '<span class="d2h-code-line-ctn"><code>$1</code></span>');
    };
    NgCodeDiffComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ng-code-diff',
                    template: "\n  <div id=\"code-diff\" [innerHtml]=\"html\"></div>\n  "
                }] }
    ];
    /** @nocollapse */
    NgCodeDiffComponent.ctorParameters = function () { return [
        { type: DomSanitizer }
    ]; };
    NgCodeDiffComponent.propDecorators = {
        oldStr: [{ type: Input }],
        newStr: [{ type: Input }],
        context: [{ type: Input }],
        outputFormat: [{ type: Input }]
    };
    return NgCodeDiffComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgCodeDiffModule = /** @class */ (function () {
    function NgCodeDiffModule() {
    }
    NgCodeDiffModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [NgCodeDiffComponent],
                    imports: [],
                    exports: [NgCodeDiffComponent]
                },] }
    ];
    return NgCodeDiffModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgCodeDiffService, NgCodeDiffComponent, NgCodeDiffModule };

//# sourceMappingURL=ng-code-diff.js.map